<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallBlog extends CPlugin{
	
	var $tplvars; 

	function COXYMallblog() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

		if (stristr($_GET["sub"], "oxymall.plugin.blog.")) {
			$sub = str_replace( "oxymall.plugin.blog." , "" , $_GET["sub"]);

			$this->__init();

			switch ($sub) {
				case "landing":
					return $this->Landing();
				break;

				case "label":
					return $this->Category();
				break;

				case "topic":
					return $this->Topic();
				break;

				case "search":
					return $this->Search();
				break;

				case "author":
					return $this->Author();
				break;

				case "archive":
					return $this->Archive();
				break;

				case "tag":
					return $this->SearchTags();
				break;

				case "post-comment":
					return $this->PostComment();
				break;

				case "rss":
					return $this->RssFeed();
				break;

				case "rss-topic":
					return $this->TopicRssFeed();
				break;

				case "rss-comments":
					return $this->RssComments();
				break;

				case "page":
					return $this->Page();
				break;

			}
			
		}
		
	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/blog/";

		$templates = array(
			"landing" => "landing.htm",
			"topics" => "topics.htm",
			"archive" => "archive.htm",
			"topic" => "topic.htm",
			"pages" => "pages.htm",
			"rss" => "rss-topics.xml",
			"rss-topic" => "rss-topic.xml",
			"rss-comments" => "rss-comments.xml",
			"twitter" => "twitter.htm",
			"flickr" => "flickr.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}
	}

	function Landing() {
		global $_TSM;

		//load the seo fields from module

		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
				$this->tpl_module,
				"",
				$this->private->templates["landing"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"]))
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",

			)
		);


		return $this->private->templates["landing"]->blockReplace(
			"Main",
			array(
				"sidebar"	=> $this->SideMenu(),
				"content"	=> $this->GetTopics(
					null,
					array(
						"first"	=> $this->tpl_module["mod_url"] . "/",
						"all"	=> $this->tpl_module["mod_url"] . "/{PAGE}/",
					),
					$this->tpl_module["settings"]["set_topics_all"]
				),

			)
		);
	}


	function Archive() {
		global $_TSM;

		//load the seo fields from module
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module,
			$this->private->templates["topics"]->BlockReplace(
				"HeaderArchive",	
				array(
					"month_name" => $this->private->templates["archive"]->blockReplace("Month_" . (int)$_GET["month"] , array()),
					"year" => $_GET["year"],
				)
			),
			$this->private->templates["landing"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"]))

		);


		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				$this->private->templates["archive"]->blockReplace("Month_" . (int)$_GET["month"] , array()) . ", " . $_GET["year"] => $this->tpl_module["mod_url"] . "/archive/" . $_GET["month"] . "-" . $_GET["year"] . "/"
			)
		);

		return $this->private->templates["landing"]->blockReplace(
			"Main",
			array(
				"sidebar"	=> $this->SideMenu(),
				"content"	=> $this->GetTopicsArchive(
					(int)$_GET["month"],
					(int)$_GET["year"],
					array(
						"first"	=> $this->tpl_module["mod_url"] . "/archive/{$_GET[month]}-{$_GET[year]}/",
						"all"	=> $this->tpl_module["mod_url"] . "/archive/{$_GET[month]}-{$_GET[year]}/{PAGE}/",
					),
					$this->tpl_module["settings"]["set_topics_archive"]
				),

			)
		);
	}

	function Search() {
		global $_TSM;

		$_GET["q"] = urldecode($_GET["q"]);

		//load the seo fields from module
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module,
			$this->private->templates["topics"]->BlockReplace(
				"HeaderSearch",	
				array("q" => stripslashes($_GET["q"]))
			),
			$this->private->templates["landing"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"]))
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				"Search Results"	=> "",
			)
		);


		return $this->private->templates["landing"]->blockReplace(
			"Main",
			array(
				"sidebar"	=> $this->SideMenu(),
				"content"	=> $this->SearchTopics(
					$_GET["q"],
					array(
						"first"	=> $this->tpl_module["mod_url"] . "/search/?q={$_GET[q]}",
						"all"	=> $this->tpl_module["mod_url"] . "/search/?q={$_GET[q]}&page={PAGE}",
					),
					"",
					$this->tpl_module["settings"]["set_topics_search"]
				),
			)
		);
	}

	function Author() {
		global $_TSM , $_CONF;

		$_GET["author"] = urldecode($_GET["author"]);

		//load the seo fields from module
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$author = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:blog_authors']} WHERE item_url='{$_GET[author]}'");

		if (!is_array($author)) {
			urlredirect($_CONF["url"] . $this->tpl_module["mod_url"] . "/" );
		}

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module,
			$this->private->templates["topics"]->BlockReplace(
				"HeaderAuthor",	
				array("author" => stripslashes($author["item_name"]))
			),
			$this->private->templates["landing"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"]))
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				"Articles by " . $author["item_name"]	=> $this->tpl_module["mod_url"] . "/author/" . $_GET['author'] . "/",
			)
		);

		

		return $this->private->templates["landing"]->blockReplace(
			"Main",
			array(
				"sidebar"	=> $this->SideMenu(),
				"content"	=> $this->private->templates["landing"]->blockReplace(
					"Author",
					$author
				) . $this->SearchTopics(
					$author["item_id"],
					array(
						"first"	=> $this->tpl_module["mod_url"] . "/author/{$_GET[author]}/",
						"all"	=> $this->tpl_module["mod_url"] . "/author/{$_GET[author]}/{PAGE}/",
					),
					"author",
					$this->tpl_module["settings"]["set_topics_author"]
				),
				"header" => $this->private->templates["topics"]->BlockReplace(
					"HeaderAuthor",	
					array("author" => stripslashes($_GET["author"]))
				),

			)
		);
	}

	function SearchTags() {
		global $_TSM;

		//fix the tag
		$_GET["tag"] = urldecode($_GET["tag"]);

		//load the seo fields from module
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		//update the tags
		$tag = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:blog_tags']} WHERE tag_code='{$_GET[tag]}'");


		if (is_array($tag)) {
			$this->db->QueryUpdate(
				$this->tables['plugin:blog_tags'],
				array(
					"tag_hits" => $tag["tag_hits"] + 1
				),
				"tag_id={$tag[tag_id]}"
			);
		} else {
			$this->db->QueryInsert(
				$this->tables['plugin:blog_tags'],
				array(
					"tag_hits" => 1,
					"tag_code"	=> $_GET["tag"],
					"module_id"	=> $this->tpl_module["mod_id"],
				)
			);
		}
		
		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module,
			$this->private->templates["topics"]->BlockReplace(
				"HeaderSearchTag",	
				$tag
			),
			$this->private->templates["landing"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"]))
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				"Search Results"	=> "",
			)
		);

		return $this->private->templates["landing"]->blockReplace(
			"Main",
			array(
				"sidebar"	=> $this->SideMenu(),
				"content"	=> $this->SearchTopics(
					$_GET["tag"],
					array(
						"first"	=> $this->tpl_module["mod_url"] . "/tags/{$_GET[tag]}/",
						"all"	=> $this->tpl_module["mod_url"] . "/tags/{$_GET[tag]}/{PAGE}/",
					),
					"tag",
					$this->tpl_module["settings"]["set_topics_tag"]
				)
			)
		);
	}

	function Category() {
		global $_TSM;

		$category = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:blog_cats']} WHERE cat_url='{$_GET[label]}' AND module_id={$this->tpl_module[mod_id]}");

		$this->module->plugins["modules"]->SetSeo($category);
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module,
			$this->private->templates["topics"]->BlockReplace(
				"HeaderCategory",	
				$category
			),
			$this->private->templates["landing"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"]))
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				$category["cat_title"] => $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "/"
			)
		);


		return $this->private->templates["landing"]->blockReplace(
			"Main",
			array(
				"sidebar"	=> $this->SideMenu(),
				"content"	=> $this->GetTopics(
					$category,
					array(
						"first"	=> $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "/",
						"all"	=> $this->tpl_module["mod_url"] . "/" . $category["cat_url"] . "/{PAGE}/",
					),
					$this->tpl_module["settings"]["set_topics_category"]
				)
			)
		);
	}

	function GetTopics($category = null, $links , $count) {
		$topics = $this->__getTopics($category , $count , $_GET["page"] );

		global $base;

		return $this->private->templates["topics"]->blockREplace(
			"Main",
			array(
				"topics" => $base->html->Table(
					$this->private->templates["topics"],
					"",
					$topics["records"]
				),

				"pagination"=> $this->module->plugins["paging"]->Paging(
					$topics["pages"] , 
					$topics["page"], 
					$links
				),
			)
		);
		
	}

	function GetTopicsArchive($month , $year, $links , $count) {
		$topics = $this->__getArchive($month , $year , $count , $_GET["page"] );

		global $base;

		return $this->private->templates["topics"]->blockREplace(
			"Main",
			array(
				"topics" => $base->html->Table(
					$this->private->templates["topics"],
					"",
					$topics["records"]
				),

				"pagination"=> $this->module->plugins["paging"]->Paging(
					$topics["pages"] , 
					$topics["page"], 
					$links
				),
			)
		);
		
	}

	function SearchTopics($q , $links , $field = "" , $count) {
		$topics = $this->__searchTopics($q, $count , $_GET["page"] , $field);

		global $base;

		return $this->private->templates["topics"]->blockREplace(
			"Main",
			array(
				"topics" => $base->html->Table(
					$this->private->templates["topics"],
					"",
					$topics["records"]
				),

				"pagination"=> $this->module->plugins["paging"]->Paging(
					$topics["pages"] , 
					$topics["page"], 
					$links
				),
			)
		);
		
	}

	function __getTopics($category , $count , $page) {
		global $_DOMAIN_ID;

		$page = (int)$page ? $page : 1;

		if ($category !== null) {
			$conds = "find_in_set({$category[cat_id]} , item_cats) AND ";
		}
		

		//debug($conds);

		$fields = "*";
		
		$products = $this->db->QFetchRowArray(
			"SELECT {$fields} " . 
			"FROM {$this->tables['plugin:blog_items']} " . 
			"WHERE " . 
			$conds .
			"module_id={$this->tpl_module[mod_id]} ".
			"ORDER BY  item_date DESC " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);

		//get the elements count
		$products_count = $this->db->RowCount(
			$this->tables['plugin:blog_items'],
			"WHERE " . 
			$conds .
			"module_id={$this->tpl_module[mod_id]} "
		);

		if (is_array($products)) {
			$this->ProcessTopics(&$products);
		}
		
		
		return array(
			"records"	=> $products , 
			"count"		=> $products_count , 
			"pages"		=> $products_count ? ceil($products_count / $count) : 1,
			"page"		=> $page,
			"search"	=> $conds["search"]
		);		

	}

	function __getArchive($month , $year , $count , $page) {
		global $_DOMAIN_ID;

		$page = (int)$page ? $page : 1;

		$conds = "item_date_month={$month} AND item_date_year={$year} AND ";
		

		//debug($conds);

		$fields = "*";
		
		$products = $this->db->QFetchRowArray(
			"SELECT {$fields} " . 
			"FROM {$this->tables['plugin:blog_items']} " . 
			"WHERE " . 
			$conds .
			"module_id={$this->tpl_module[mod_id]} ".
			"ORDER BY  item_date DESC " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);

		//get the elements count
		$products_count = $this->db->RowCount(
			$this->tables['plugin:blog_items'],
			"WHERE " . 
			$conds .
			"module_id={$this->tpl_module[mod_id]} "
		);

		if (is_array($products)) {
			$this->ProcessTopics(&$products);
		}
		
		
		return array(
			"records"	=> $products , 
			"count"		=> $products_count , 
			"pages"		=> $products_count ? ceil($products_count / $count) : 1,
			"page"		=> $page,
			"search"	=> $conds["search"]
		);		

	}

	function __searchTopics($q , $count , $page , $field = "") {
		global $_DOMAIN_ID;

		$page = (int)$page ? $page : 1;

		
		if ($q) {

			if ($field == "author") {
				$conds = " item_author='$q' AND ";
			} else {			
				$q = explode(" " , $q);

				foreach ($q as $key => $val) {
					
					//search only in tag
					if ($field == "tag")
						$q_sql[] = " (item_tags LIKE '%{$val}%') ";
					else				
						$q_sql[] = " (item_title LIKE '%{$val}%' OR item_tags LIKE '%{$val}%') ";
				}

				$conds = " (" .  implode(" AND " , $q_sql) . ") AND ";
			}
		}
				

		//debug($conds);

		$fields = "*";
		
		$products = $this->db->QFetchRowArray(
			"SELECT {$fields} " . 
			"FROM {$this->tables['plugin:blog_items']} " . 
			"WHERE " . 
			$conds .
			"module_id={$this->tpl_module[mod_id]} ".
			"ORDER BY  item_date DESC " . 
			"LIMIT " . ( ($page - 1 ) * $count ) . " , " . $count 
		);

		//get the elements count
		$products_count = $this->db->RowCount(
			$this->tables['plugin:blog_items'],
			"WHERE " . 
			$conds .
			"module_id={$this->tpl_module[mod_id]} "
		);

		if (is_array($products)) {
			$this->ProcessTopics(&$products);
		}
		
		
		return array(
			"records"	=> $products , 
			"count"		=> $products_count , 
			"pages"		=> $products_count ? ceil($products_count / $count) : 1,
			"page"		=> $page,
			"search"	=> $conds["search"]
		);		

	}

	function Topic() {
		global $base , $_TSM;

		$topic = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['plugin:blog_items']} WHERE item_id='{$_GET[topic]}' and module_id={$this->tpl_module[mod_id]}"
		);

		//process the date
		$topic["day"] = date("d" ,$topic["item_date"]);
		$topic["year"] = date("y" ,$topic["item_date"]);
		$topic["month"] = date("M" ,$topic["item_date"]);
		$topic["date"] = date($this->tpl_module["settings"]["set_date_format_topics"] , $topic["item_date"]);

		$topic["image"] = $topic["item_image"] ? $this->private->templates["topic"]->BlockReplace("Image" , $topic) : "";					

		$topic["mod_url"] = $this->tpl_module["mod_url"];

		//process topics
		if (trim($topic["item_tags"])) {
			$tmp = explode("," , $topic["item_tags"]);
			$tags = array();
			
			foreach ($tmp as $k => $v) {
				$tags[] = array(
					"mod_url" => $this->tpl_module["mod_url"] , 
					"code" => trim($v),
					"sep" => $k == count($tmp)-1 ? "" : $this->private->templates["topic"]->BlockReplace("TagsSep", array()),
				);
			}
			
			$topic["tags"] = $base->html->table(
				$this->private->templates["topic"],
				"Tags",
				$tags
			);
		} else {
			$topic["tags"] = "";
		}

		//process categories
		if ($topic["item_cats"]) {
			$cats = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:blog_cats']} WHERE cat_id in ({$topic[item_cats]})");
			
			foreach ($cats as $k => $v) {
				$cats[$k]["sep"] = $k == count($cats)-1 ? "" : $this->private->templates["topic"]->BlockReplace("CatsSep", array());
				$cats[$k]["mod_url"] = $this->tpl_module["mod_url"];
			}

			$topic["categories"] = $base->html->table(
				$this->private->templates["topic"],
				"Cats",	
				$cats
			);
		} else {
			$topic["categories"] = "";
		}

		//process for author

		$author = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:blog_authors']} WHERE item_id='{$topic[item_author]}'");

		$topic["author_name"] = $author["item_name"];
		$topic["author_url"] = $author["item_url"];

		
		//process seo fields
		$this->module->plugins["modules"]->SetSeo($topic);
		$this->module->plugins["modules"]->SetSeo($this->tpl_module);

		$topic["author"] = $this->TopicAuthor($topic["item_author"]);
		
		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo($this->tpl_module , "" , $this->private->templates["landing"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"])));

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				$topic["item_title"] => $this->tpl_module["mod_url"] . "/" . $topic["item_url"] . "-" . $topic["item_id"] . "/" 
			)
		);

		
		return $this->private->templates["topic"]->BlockReplace(
			"Main",
			array(
				"sidebar"	=> $this->SideMenu(),
				"content"	=> $this->private->templates["topic"]->BlockReplace(
						"Details",
						$topic
				),

				"comments"	=> $this->Comments($topic),
				"addcomment"	=> $this->AddComment($topic),

				"mod_url"		=> $this->tpl_module["mod_url"],
			)
		);
	}
	
	
	function ProcessTopics($topics) {
		global $base;

		if (is_array($topics)) {

			$_cats = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:blog_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC");

			if (is_Array($_cats)) {
				foreach ($_cats as $key => $val) {
					$cats[$val["cat_id"]] = $val;
				}
			}
			

			foreach ($topics as $key => $val) {
				$topics[$key]["image"] = $val["item_image"] ? $this->private->templates["topics"]->BlockReplace("BriefImage" , $val) : "";				
				$topics[$key]["day"] = date("d" ,$val["item_date"]);
				$topics[$key]["year"] = date("y" ,$val["item_date"]);
				$topics[$key]["month"] = date("M" ,$val["item_date"]);
				$topics[$key]["mod_url"] = $this->tpl_module["mod_url"];
				$topics[$key]["date"] = date($this->tpl_module["settings"]["set_date_format_topics"] , $val["item_date"]);

				$topics[$key]["categories"] = "";

				//process the categories 
				if (trim($val["item_cats"])) {				
					$tmp_cats = explode("," , $val["item_cats"]);
					if (is_array($tmp_cats)) {
						foreach ($tmp_cats as $k => $v) {

							$tmp_cats[$k] = $this->private->templates["topics"]->blockReplace("Cat" , $cats[$v]);
						}						

						$topics[$key]["categories"] = CTemplateStatic::Replace(
								implode(", " , $tmp_cats) , 
								$this->tpl_module
						);
					}
				}
				


				//process for tags
				if (trim($val["item_tags"])) {
					$tmp = explode("," , $val["item_tags"]);
					$tags = array();
					
					foreach ($tmp as $k => $v) {
						$tags[] = array(
							"mod_url" => $this->tpl_module["mod_url"] , 
							"code" => trim($v),
							"sep" => $k == count($tmp)-1 ? "" : $this->private->templates["topics"]->BlockReplace("TagsSep", array()),
						);
					}
					
					$topics[$key]["tags"] = $base->html->table(
						$this->private->templates["topics"],
						"Tags",
						$tags
					);
				} else {
					$topics[$key]["tags"] = "";
				}

				$val["mod_url"] = $this->tpl_module["mod_url"];

				if ($val["item_comments"]) {
				//change in future versions
					$topics[$key]["item_comments_count"] = 
					$val["item_comments_count"] = $this->db->RowCount(
						$this->tables['plugin:blog_comments'],
						"WHERE comment_item={$val[item_id]}" . 
						($this->tpl_module["settings"]["set_comments_approval"] ? " AND comment_status=1 " : "") 				
					);				

					$topics[$key]["comments"] = $this->private->templates["topics"]->blockReplace("Comments" , $val);
				} else
					$topics[$key]["comments"] = $this->private->templates["topics"]->blockReplace("NoComments" , $val);


				//process for author
				$author = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:blog_authors']} WHERE item_id='{$val[item_author]}'");

				$topics[$key]["author_name"] = $author["item_name"];
				$topics[$key]["author_url"] = $author["item_url"];
				
			}
		}
		
	}
	

	function CategoriesMenu() {
		$cats = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:blog_cats']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY cat_order ASC");

		if (is_array($cats)) {
			$found = false;
			foreach ($cats as $key => $val) {
				if ($val["cat_url"] == $_GET["label"]) {
					$found = true;
					$cats[$key]["selected"] = $this->private->templates["landing"]->blockReplace("Selected" , array());
				} else 
					$cats[$key]["selected"] = "";				

				if ($key == count($cats)-1) {
					$cats[$key]["class"] = "last";
				} else
					$cats[$key]["class"] = "";				
			}			
		}
		
		global $base;
		return CTemplateStatic::Replace(
			$base->html->Table(
				$this->private->templates["landing"],
				"Cats",
				$cats
			),
			array(
				"first"	=> $this->private->templates["landing"]->blockReplace(
					"CatsAll" , 
					array(
						"mod_url"=> $this->tpl_module["mod_url"],
						"selected"=> $found ? "" : ($_GET["sub"] == "oxymall.plugin.blog.landing" ? $this->private->templates["landing"]->blockReplace("Selected" , array()) : "" ),
						"class"	=> is_array($cats) ? "" : "last",
					)
				),
				"mod_url"	=> $this->tpl_module["mod_url"],
			)
		);
	}

	function TagsMenu() {
		global $base;

		$tags = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:blog_tags']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY tag_hits DESC LIMIT 50");

		if (is_array($tags)) {
			foreach ($tags as $key => $val) {
				if ($key == count($tags)-1) {
					$tags[$key]["SEP"] = "";
				} else
					$tags[$key]["SEP"] = $this->private->templates["landing"]->blockReplace("TagsSep" , array());				

			}

			return CTemplateSTatic::Replace(
				$base->html->Table(
					$this->private->templates["landing"],
					"Tags",
					$tags
				),
				array(
					"mod_url"	=> $this->tpl_module["mod_url"],
				)
			);
		}
	}

	function ArchivesMenu() {
		global $base;

		//get all the archives
		$arch = $this->db->QFetchRowArray(
			"SELECT concat(item_date_month, '-',item_date_year) as arch,module_id FROM {$this->tables['plugin:blog_items']} WHERE module_id={$this->tpl_module[mod_id]} GROUP by arch"
		);

		
		
		if (is_array($arch) && count($arch)) {
			foreach ($arch as $key => $val) {
				$tmp = explode("-" , $val["arch"]);

				$arch[$key]["month"] = $tmp[0];
				$arch[$key]["year"] = $tmp[1];

				if (($_GET["month"] == $tmp[0])&& ($_GET["year"] == $tmp[1])) {
					$found = true;
					$arch[$key]["selected"] = $this->private->templates["archive"]->BlockReplace("Selected", array());
				} else 
					$arch[$key]["selected"] = "";

				if ($key == 0) {
					$arch[$key]["class"] = "first";
				} else {
					if ($key == count($arch)-1) {
						$arch[$key]["class"] = "last";
					}
					
				}
				
				
				$arch[$key]["month_name"] = $this->private->templates["archive"]->BlockReplace("Month_" . (int)$tmp[0], array());
				$arch[$key]["mod_url"] = $this->tpl_module["mod_url"];
			}

			return CTemplateStatic::Replace(
				$base->html->table(
					$this->private->templates["archive"],
					"",
					$arch
				),
				array(
					"selected" => $found ? "selected" : ""
				)
			);
			
		}

		return "";

	}
	
	function Banners() {
		return "";
	}
	
	
	
	


	function GetAllLinks($module , $links) {
		//get all news for this module

		$cats = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:blog_cats']} WHERE module_id={$module[mod_id]} ORDER BY cat_order ASC");

		if (is_array($cats)) {

			foreach ($cats as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/" . $val["cat_url"] . "/",
					"priority"	=> "0.6",
				);
			}			
		}

		//topics
		$items = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:blog_items']} WHERE module_id={$module[mod_id]} ORDER BY item_date ASC");

		if (is_array($items)) {

			foreach ($items as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/" . $val["item_url"] . "-" . $val["item_id"] . "/",
					"priority"	=> "0.6",
				);
			}			
		}

		//pages
		$items = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:blog_pages']} WHERE module_id={$module[mod_id]} ORDER BY item_order ASC");

		if (is_array($items)) {

			foreach ($items as $key => $val) {
				$links[] = array(
					"url" => $module["mod_url"] . "/page/" . $val["item_url"] . "-" . $val["item_id"] . "/",
					"priority"	=> "0.6",
				);
			}			
		}

	}


	function PostComment() {
		global $_CONF;

		$this->tpl_module = $this->module->plugins["modules"]->LoadModuleInfo();

		if (!is_array($topic = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:blog_items']} WHERE item_id='{$_GET[t]}'"))) {
			echo $this->private->templates["topic"]->BlockReplace(
				"ErrorTopic",
				array()
			);
			die();
		}

		if (!$topic["item_comments"]) {
			echo $this->private->templates["topic"]->BlockReplace(
				"ErrorComments",
				array()
			);
			die();
		}

		if(!preg_match("/^([a-zA-Z0-9])+([a-zA-Z0-9\._-])*@([a-zA-Z0-9_-])+([a-zA-Z0-9\._-]+)+$/",$_POST["email"])){
			echo $this->private->templates["topic"]->BlockReplace(
				"ErrorEmail",
				array()
			);
			die("");
		}

		$vars = array(
			"name" => stripslashes($_POST["name"]),
			"email" => stripslashes($_POST["email"]),
			"message" => nl2br(strip_tags(stripslashes($_POST["message"]))),
		);

		foreach ($vars as $key => $val) {
			if (trim($val)=="") {
				echo $this->private->templates["topic"]->BlockReplace(
					"ErrorFields",
					array()
				);
				die();
			}
		}

		//add the topics vars to mail
		$vars = array_merge(
			$vars , 
			$topic 
		);

		$vars["site_url"] = $_CONF["url"];

		//save the email to database
		$id = $this->db->QueryInsert(
			$this->tables["plugin:blog_comments"],
			$resume = array(
				"comment_date"	=> time(),
				"comment_item"	=> $topic["item_id"],
				"module_id"		=> $topic["module_id"],

				"comment_email"	=> $vars["email"],
				"comment_url"	=> $_POST["website"],
				"comment_name"	=> $vars["name"],
				"comment_message"	=> $vars["message"],
			)
		);

		if ($this->tpl_module["settings"]["set_email_1"]) {

			$email = array(
				"email_to" => utf8_decode($this->tpl_module["settings"]["set_email_1_to_email"]),
				"email_to_name" => utf8_decode($this->tpl_module["settings"]["set_email_1_to_name"]),

				"email_from" => utf8_decode($this->tpl_module["settings"]["set_email_1_from_email"]),
				"email_from_name" => utf8_decode($this->tpl_module["settings"]["set_email_1_from_name"]),

				"email_subject" => utf8_decode($this->tpl_module["settings"]["set_email_1_subject"]),
				"email_body" => utf8_decode($this->tpl_module["settings"]["set_email_1_message"]),
				"email_type" => "html"				
				);

			foreach ($email as $key => $val) {
				$email[$key] = CTemplateStatic::Replace($val , $vars);
			}


			//send the email
			$this->module->plugins["mail"]->SendMail($email);
		}

		//send the responder
		if ($this->tpl_module["settings"]["set_email_2"]) {

				$email = array(	
				"email_to" => utf8_decode($vars["email"]),
				"email_to_name" => utf8_decode($vars["name"]),

				"email_from" => utf8_decode($this->tpl_module["settings"]["set_email_2_to_email"]),
				"email_from_name" => utf8_decode($this->tpl_module["settings"]["set_email_2_to_name"]),

				"email_subject" => utf8_decode($this->tpl_module["settings"]["set_email_2_subject"]),
				"email_body" => utf8_decode($this->tpl_module["settings"]["set_email_2_message"]),
				"email_type" => "html"
			);

			foreach ($email as $key => $val) {
				$email[$key] = CTemplateStatic::Replace($val , $vars);
			}

			//send the email
			$this->module->plugins["mail"]->SendMail($email);	
		}
		echo $this->private->templates["topic"]->BlockReplace(
			"ErrorSuccess",
			array()
		);
		die();
		
	}

	function Comments($topic) {
		global $base;
		$comments = $this->getComments($topic , $this->tpl_module["settings"]["set_comments"] , $_GET["page"]);

		if (!$comments["count"]) {
			return "";
		}

		if ($topic["item_comments"]) {
			$topic["leave_comment"] = $this->private->templates["topic"]->BlockReplace(
				"LeaveComment",
				""
			);
		} else 
			$topic["leave_comment"] = "";

		return $this->private->templates["topic"]->blockreplace(
			"Comments",
			array(
				"items" => $base->html->table(
						$this->private->templates["topic"],
						"Comments",
						$comments["records"]
				),

				"leave_comment"	=> $topic["leave_comment"] ? $this->private->templates["topic"]->BlockReplace(
					"LeaveComment",
					array()
				) : "",
				"count"	=> $comments["count"],

				"paging"=> $this->module->plugins["paging"]->Paging(
					$comments["pages"] , 
					$comments["page"], 
					array(
						"last" => $this->tpl_module["mod_url"] . "/" . $topic["item_url"] . "-" . $topic["item_id"] . "/",
						"all" => $this->tpl_module["mod_url"] . "/" . $topic["item_url"] . "-" . $topic["item_id"] . "/{PAGE}/",
						"first" => $this->tpl_module["mod_url"] . "/" . $topic["item_url"] . "-" . $topic["item_id"] . "/{PAGE}/",
					)
				),

				"item_title"	=> $topic["item_title"],
		
			)
		);
	}

	function getComments($topic , $count , $page) {
		global $_DOMAIN_ID , $_CONF;

		$fields = "*";

		$products_count = $this->db->RowCount(
			$this->tables['plugin:blog_comments'],
			"WHERE " . 
			"comment_item={$topic[item_id]} AND " .
			"module_id={$this->tpl_module[mod_id]} " . 
			($this->tpl_module["settings"]["set_comments_approval"] ? " AND comment_status=1 " : "")
		);

		if (!$page && $products_count) {
			$page = ceil($products_count / $count);
		} else 
			$page = (int)$page;
		
		
		$products = $this->db->QFetchRowArray(
			"SELECT {$fields} " . 
			"FROM {$this->tables['plugin:blog_comments']} " . 
			"WHERE " . 
			"comment_item={$topic[item_id]} AND " .
			"module_id={$this->tpl_module[mod_id]} ".
			($this->tpl_module["settings"]["set_comments_approval"] ? " AND comment_status=1 " : "") . 
			"ORDER BY  comment_date ASC " . 
			"LIMIT " . ( max(0,($page - 1 ) * $count )) . " , " . $count 
		);

		//get the elements count

		if (is_array($products)) {

			foreach ($products as $key => $val) {
				$val["email_md5"] = md5($val["comment_email"]);
				$val["url_encoded"] = urlencode($_CONF["url"]);
				$products[$key]["comment_date"] = date($this->tpl_module["settings"]["set_date_format_comments"] , $val["comment_date"]);
				$products[$key]["comment_time"] = $val["comment_time"] = date($this->tpl_module["settings"]["set_time_format_comments"] , $val["comment_date"]);

				$products[$key]["gravatar"] = $this->private->templates["topic"]->BlockReplace(
					"CommentAvatar",
					$val
				);

				$products[$key]["author"] =  $this->private->templates["topic"]->blockReplace(
					$val["comment_url"] ? "CommentLink" : "CommentNoLink",
					$val
				);

			}
			
		}
				
		return array(
			"records"	=> $products , 
			"count"		=> $products_count , 
			"pages"		=> $products_count ? ceil($products_count / $count) : 1,
			"page"		=> $page,
			"search"	=> $conds["search"]
		);		

	}

	
	function AddComment($topic) {

		if (!$topic["item_comments"]) {
			return "";
		}
		
		return $this->private->templates["topic"]->blockreplace(
			"AddComment",
			array(
				"m"	=> $topic["module_id"],
				"i"	=> $topic["item_id"],
			)
		);
	}

	function SearchMenu() {

		return $this->private->templates["landing"]->BlockReplace(
			"Search",
			array(
				"mod_url" => $this->tpl_module["mod_url"],
			)
		);
	}

	function SideMenu() {
		return cTemplateStatic::Replace(
			$this->tpl_module["settings"]["set_sidebar"],
			array(
				"categories"=> $this->CategoriesMenu(),
				"search"	=> $this->SearchMenu(),
				"archives"	=> $this->ArchivesMenu(),
				"banners"	=> $this->Banners(),
				"tags"		=> $this->TagsMenu(),
				"rss"		=> $this->Rss(),
				"pages"		=> $this->PagesMenu(),
				"twitter"	=> $this->TwitterMenu(),
				"flikr"		=> $this->FlickrMenu(),
			)
		);
	}

	function Rss() {
		return $this->private->templates["landing"]->BlockReplace(
			"Rss",
			$this->tpl_module
		);
	}
	
	function RssFeed() {
		global $base , $_CONF;

		$topics = $this->getRssTopics();

		if (is_Array($topics)) {
			foreach ($topics as $key => $val) {
				if ($date < $val["item_date"]) {
					$date = $val["item_date"];
				}
				
			}			
		}
		

		return CTemplateStatic::Replace(
			$this->private->templates["rss"]->blockREplace(
				"Main" , 
				array(
					"items"	=> $base->html->Table(
						$this->private->templates["rss"],
						"Topics",
						$topics
					)
				)
			),
			array(
				"site_url"		=> $_CONF["url"],
				"mod_url"		=> $this->tpl_module["mod_url"],
				"title"			=> "",

				"date"	=> date("+r" , $date),

				"set_rss_title"	=> $this->tpl_module["settings"]["set_rss_title"],
				"set_rss_description"	=> $this->tpl_module["settings"]["set_rss_description"],
				"set_rss_lang"	=> $this->tpl_module["settings"]["set_rss_lang"],
				"set_rss_update"	=> $this->tpl_module["settings"]["set_rss_update"],
				"set_rss_freq"	=> $this->tpl_module["settings"]["set_rss_freq"],

			)
		);
	}

	function GetRssTopics() {
		global $base;

		$count = $this->tpl_module["settings"]["set_rss_items_topics"];

		$topics = $this->db->qfetchRowArray(
			"SELECT * FROM {$this->tables['plugin:blog_items']} " . 
			"WHERE module_id = {$this->tpl_module['mod_id']} " . 
			"ORDER BY item_date DESC LIMIT {$count}"
		);

		//get all the categories
		$_labels = $this->db->QFetchRowArray(
			"SELECT * FROM {$this->tables['plugin:blog_cats']} " .
			"WHERE module_id = {$this->tpl_module['mod_id']} "
		);

		if (is_array($_labels)) {
			foreach ($_labels as $key => $val) {
				$labels[$val["cat_id"]] = $val;
			}			
		}

		if (is_array($topics)) {
			foreach ($topics as $key => $val) {
				$cats = array();

				$topics[$key]["date"] = date("+r" , $val["item_date"]);

				//process the categoris
				if ($val["item_cats"]) {
					$tmp = explode("," , $val["item_cats"]);
					
					if (is_array($tmp)) {
						foreach ($tmp as $k => $v) {
							$cats[] = $labels[trim($v)];
						}						
					}					
				}
				
				$topics[$key]["categories"] = $base->html->table(
					$this->private->templates["rss"],
					"Cats",
					$cats
				);

				//process the extra image
				$topics[$key]["image"] = $val["item_image"] ? $this->private->templates["rss"]->blockReplace("Image" , $val) : "";

				//process for topics count
				
				$topics[$key]["item_comments_count"] = $this->db->RowCount(
					$this->tables['plugin:blog_comments'],
					"WHERE comment_item={$val[item_id]}" . 
					($this->tpl_module["settings"]["set_comments_approval"] ? " AND comment_status=1 " : "") 				
				);

			}			
		}
/*
		$this->module->EncodeItems(
			&$cats , 
			array(
				"item_title"
			)
		);
*/				

		return $topics;
	}

	function TopicRssFeed() {
		global $base , $_CONF;

		$topic = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['plugin:blog_items']} WHERE item_id='{$_GET[topic]}' and module_id={$this->tpl_module[mod_id]}"
		);

		$comments = $this->getRssComments($topic );

		if (is_Array($comments)) {
			foreach ($comments as $key => $val) {
				if ($date < $val["comment_date"]) {
					$date = $val["comment_date"];
				}
				
			}			
		}
		

		return CTemplateStatic::Replace(
			$this->private->templates["rss-topic"]->blockREplace(
				"Main" , 
				array(
					"items"	=> $base->html->Table(
						$this->private->templates["rss-topic"],
						"Items",
						$comments
					)
				)
			),
			array(
				"site_url"		=> $_CONF["url"],
				"mod_url"		=> $this->tpl_module["mod_url"],
				"item_url"		=> $topic["item_url"],
				"item_id"		=> $topic["item_id"],
				"item_title"	=> $topic["item_title"],
				"item_brief"	=> strip_tags($topic["item_brief"]),

				"date"	=> date("+r" , $date),

				"set_rss_title"	=> $topic["item_title"],
				"set_rss_description"	=> "",
				"set_rss_lang"	=> $this->tpl_module["settings"]["set_rss_lang"],
				"set_rss_update"	=> $this->tpl_module["settings"]["set_rss_update"],
				"set_rss_freq"	=> $this->tpl_module["settings"]["set_rss_freq"],

			)
		);
	}
	

	function GetRssComments($topic) {
		global $_CONF;

		$count = $this->tpl_module["settings"]["set_rss_items_topic"];		
		$comments = $this->db->QFetchRowArray(
			"SELECT * " . 
			"FROM {$this->tables['plugin:blog_comments']} " . 
			"WHERE " . 
			"comment_item={$topic[item_id]} AND " .
			"module_id={$this->tpl_module[mod_id]} ".
			($this->tpl_module["settings"]["set_comments_approval"] ? " AND comment_status=1 " : "") . 
			"ORDER BY  comment_date DESC "  .
			"LIMIT {$count} "
		);

		if (is_array($comments)) {
			foreach ($comments as $key => $val) {
				$comments[$key]["comment_message_strip"] = strip_tags($val["comment_message"]);
				$comments[$key]["date"] = date("+r" , $val["comment_date"]);
				$comments[$key]["email_md5"] = md5($val["comment_email"]);
				$comments[$key]["url_encoded"] = urlencode($_CONF["url"]);

			}			
		}
		

		return $comments;

	}

	
	function RssComments() {
		global $base , $_CONF;

		$comments = $this->getRssFullComments($topic );

		if (is_Array($comments)) {
			foreach ($comments as $key => $val) {
				if ($date < $val["comment_date"]) {
					$date = $val["comment_date"];
				}
				
			}			
		}
		

		return CTemplateStatic::Replace(
			$this->private->templates["rss-comments"]->blockREplace(
				"Main" , 
				array(
					"items"	=> $base->html->Table(
						$this->private->templates["rss-comments"],
						"Items",
						$comments
					)
				)
			),
			array(
				"site_url"		=> $_CONF["url"],
				"mod_url"		=> $this->tpl_module["mod_url"],
				"item_url"		=> $topic["item_url"],
				"item_id"		=> $topic["item_id"],
				"item_title"	=> $topic["item_title"],
				"item_brief"	=> strip_tags($topic["item_brief"]),

				"date"	=> date("+r" , $date),

				"set_rss_title"	=> $this->tpl_module["settings"]["set_rss_title"],
				"set_rss_description"	=> $this->tpl_module["settings"]["set_rss_description"],
				"set_rss_lang"	=> $this->tpl_module["settings"]["set_rss_lang"],
				"set_rss_update"	=> $this->tpl_module["settings"]["set_rss_update"],
				"set_rss_freq"	=> $this->tpl_module["settings"]["set_rss_freq"],
			)
		);
	}
	

	function GetRssFullComments() {
		global $_CONF;

		$count = $this->tpl_module["settings"]["set_rss_items_comments"];		

		$comments = $this->db->QFetchRowArray(
			"SELECT * " . 
			"FROM {$this->tables['plugin:blog_comments']} as c, {$this->tables['plugin:blog_items']} " . 
			"WHERE " . 
			
			"comment_item=item_id AND " .
			"c.module_id={$this->tpl_module[mod_id]} ".
			($this->tpl_module["settings"]["set_comments_approval"] ? " AND comment_status=1 " : "") . 
			"ORDER BY  comment_date DESC "  .
			"LIMIT {$count} "
		);

		if (is_array($comments)) {
			foreach ($comments as $key => $val) {
				$comments[$key]["comment_message_strip"] = strip_tags($val["comment_message"]);
				$comments[$key]["date"] = date("+r" , $val["comment_date"]);
				$comments[$key]["email_md5"] = md5($val["comment_email"]);
				$comments[$key]["url_encoded"] = urlencode($_CONF["url"]);

			}			
		}
		

		return $comments;

	}

	function TopicAuthor($id) {
		$author = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:blog_authors']} WHERE item_id='{$id}'");

		if (is_array($author)) {

			return $this->private->templates["topic"]->blockreplace(
				"Author",
				$author
			);
		}		
	}


	function PagesMenu() {
		global $base;

		$pages = $this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:blog_pages']} WHERE module_id={$this->tpl_module[mod_id]} ORDER BY item_order ASC");

		if (is_array($pages)) {

			return CTemplateStatic::Replace(
				$base->html->table(
					$this->private->templates["pages"],
					"Menu" , 
					$pages
				),
				array(
					"mod_url"	=> $this->tpl_module["mod_url"],
					"title"		=> $this->tpl_module["settings"]["set_pages_title"],
				)
			);

		}
		
	}
	
	function Page() {
		global $base , $_TSM;

		$page = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:blog_pages']} WHERE module_id={$this->tpl_module[mod_id]} AND item_id='{$_GET[page]}' ");

		$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo(
			$this->tpl_module,
			"",
			$this->private->templates["landing"]->blockReplace("SearchHeader" , array("mod_url" => $this->tpl_module["mod_url"]))
		);

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				$this->tpl_module["mod_long_name"] => $this->tpl_module["mod_url"] . "/",
				$page["item_title"] => $this->tpl_module["mod_url"] . "/blog/" . $page["item_url"] . "-" . $page["item_id"] . "/"
			)
		);

		if (is_array($page)) {

			$this->module->plugins["modules"]->SetSeo($page);
			$this->module->plugins["modules"]->SetSeo($this->tpl_module);


			return CTemplateStatic::Replace(
				$this->private->templates["pages"]->blockReplace(
					"Page" , 
					$page
				),
				array(
					"mod_url"	=> $this->tpl_module["mod_url"],
					"sidebar"	=> $this->SideMenu(),					
				)
			);

		}
		
	}

	function TwitterMenu() {
		global $base;

		if ($this->tpl_module["settings"]["set_twitter_rss"]) {

			$filename = "upload/blog/blog_twitter_" . $this->tpl_module["mod_id"] . ".rss";

			if (file_exists($filename)) {
				$conf = new CConfig($filename);

				$topics = $conf->vars["rss"]["channel"]["item"];

				if (!is_Array($topics)) {
					return "";
				}
				

				if (!is_array($topics[0])) {
					$topics = array( 0 => $topics );
				}
				

				if (is_array($topics) && count($topics)) {

					$topics =  array_slice($topics, 0, $this->tpl_module["settings"]["set_twitter_items"]);

					return CTemplateStatic::Replace(
						$base->html->table(
							$this->private->templates["twitter"],
							"",
							$topics
						),
						array(
							"title"	=> $this->tpl_module["settings"]["set_twitter_title"],
						)
					);
				}
				
			}
			
			
		}
		
	}

	function FlickrMenu() {
		global $base;

		if ($this->tpl_module["settings"]["set_flickr_rss"]) {

			$filename = "upload/blog/blog_flickr_" . $this->tpl_module["mod_id"] . ".rss";

			if (file_exists($filename)) {
				$conf = new CConfig($filename);

				//$topics = $conf->vars["feed"]["entry"];
				$topics = $conf->vars["rss"]["channel"]["item"];

				if (!is_Array($topics)) {
					return "";
				}				

				if (!is_array($topics[0])) {
					$topics = array( 0 => $topics );
				}

				if (is_array($topics) && count($topics)) {

					$topics =  array_slice($topics, 0, $this->tpl_module["settings"]["set_flickr_items"]);

					foreach ($topics as $key => $val) {

						$topics[$key] = array(
							"image"	 => $val["media:content"]["url"],
							"thumb"	 =>  $val["media:thumbnail"]["url"],
							"link"	 => $val["link"],
						);
					}

					return CTemplateStatic::Replace(
						$base->html->table(
							$this->private->templates["flickr"],
							"",
							$topics
						),
						array(
							"title"	=> $this->tpl_module["settings"]["set_flickr_title"],
						)
					);
				}
				
			}
			
			
		}
		
	}
	

	function GetLatestRecords($module , $count = 5) {
		$items = $this->db->QFetchRowArray(
			"SELECT item_id, item_title,item_url,item_date " . "FROM {$this->tables['plugin:blog_items']} " . 
			"WHERE " . "module_id={$module[mod_id]} " . 
			"ORDER BY item_date DESC " . 
			"LIMIT $count "
		);

		return $items;
	}

}

?>