<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallFooter extends CPlugin{
	
	var $tplvars; 

	function COXYMallFooter() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();
	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/footer/";

		$templates = array(
			"footer" => "footer.htm",
			"news" => "news.htm",
			"blog" => "blog.htm",
			"gallery" => "gallery.htm",
			"social" => "social.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function Footer() {
		global $base , $_TSM;
		$this->__init();

		//get all the categories
		$cats = $this->db->QFetchRowARray("SELECT * FROM {$this->tables['plugin:footer_cats']} ORDER BY cat_order ASC");
	
		
		if (is_array($cats)) {

			$fields = array(
				1	=> "one_one",
				2	=> "one_two",
				3	=> "one_third",
				4	=> "one_fourth",
				5	=> "one_fifth",
				6	=> "one_six",
			);

			foreach ($cats as $key => $val) {
				$cats[$key]["class"] = $fields[count($cats)];

				switch ($val["cat_type"]) {
					case "0":
						//get the links 
						$cats[$key]["content"]	= $base->html->table(
							$this->private->templates["footer"],
							"Links",
							$this->db->QFetchRowArray("SELECT * FROM {$this->tables['plugin:footer_items']} WHERE item_cat={$val[cat_id]} ORDER BY item_order ASC")
						);
					break;

					case "1":
						//editable text
						$cats[$key]["content"]	= $this->private->templates["footer"]->blockReplace(
							"Text",
							array(
								"text"	=> nl2br($val["cat_text"]),
							)
						);
					break;

					case "2":
						//contact module
						$cats[$key]["class"] =  "one_third";

						if ($val["cat_contact"]) {
							$module = $this->module->plugins["modules"]->GetModuleByID($val["cat_contact"]);

							$cats[$key]["content"] = $this->private->templates["footer"]->blockReplace(
								"Contact",
								array(
									"mod_id"		=> $module["mod_id"],
									"quick_subject"	=> $val["cat_contact_subject"],
									
								)
							);
						} else 
							$cats[$key]["content"] = "";
					break;

					case "3":
						//news module
						if ($val["cat_news"]) {
							$module = $this->module->plugins["modules"]->GetModuleByID($val["cat_news"]);

							$news = $this->module->plugins["news"]->GetLatestRecords($module , $val["cat_news_items"]);

							$cats[$key]["content"] = CTemplateStatic::Replace(
								$base->html->Table(
									$this->private->templates["news"],
									"",
									$news
								),
								array(
									"mod_url" => $module["mod_url"],
								)
							);
						}						
					break;

					case "4":
						//blog module
						if ($val["cat_blog"]) {
							$module = $this->module->plugins["modules"]->GetModuleByID($val["cat_blog"]);

							$topics = $this->module->plugins["blog"]->GetLatestRecords($module , $val["cat_blog_items"]);

							$cats[$key]["content"] = CTemplateStatic::Replace(
								$base->html->Table(
									$this->private->templates["blog"],
									"",
									$topics
								),
								array(
									"mod_url" => $module["mod_url"],
								)
							);
						}						
					break;

					case "5":
						//gallery module
						if ($val["cat_gallery"]) {
							$module = $this->module->plugins["modules"]->GetModuleByID($val["cat_gallery"]);

							$images = $this->module->plugins["gallery"]->GetLatestRecords($module , $val["cat_gallery_items"]);

							if (is_array($images)) {
								$alt = 0;
								foreach ($images as $k => $v) {
									$images[$k]["alt"] = $this->private->templates["gallery"]->blockReplace("alt_" . (int)$alt , array());
									$alt = !$alt;
								}								
							}
							

							$cats[$key]["content"] = CTemplateStatic::Replace(
								$base->html->Table(
									$this->private->templates["gallery"],
									"",
									$images
								),
								array(
									"mod_url" => $module["mod_url"],
								)
							);
						}						
					break;

						
				}

				$cats[$key]["content"] = CTemplateStatic::Replace(
					$cats[$key]["content"],
					$val
				);

				$cats[$key]["last"] = count($cats)-1 == $key ? "last" : "";
				
			}			

			return $base->html->Table(
				$this->private->templates["footer"],
				"Cats",
				$cats
			);
		}		
	}

	function SocialLinks() {
		global $base;

		$this->__init();

		return $base->html->Table(
			$this->private->templates["social"],
			"",
			$this->db->QFetchRowArray(
				"SELECT * FROM {$this->tables['plugin:footer_social']} ORDER BY item_order ASC"
			)
		);
	}

}

?>