<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallModules extends CPlugin{
	
	var $tplvars; 

	function COXYMallModules() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();
		
	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/common/";

		$templates = array(
			"menu" => "menu.htm",
			"info" => "info.htm",
			"breadcrumb"	=> "breadcrumb.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function GetMenu() {		
		global $base , $_SESS;

		$this->__init();

		//read all the modules
		$modules = $this->db->QFetchRowArray(
			"SELECT * FROM " . 
				$this->tables['core:modules'] . ", " . 
				$this->tables['core:user_modules'] . " " . 
			"WHERE mod_module=module_id AND mod_invisible=0 " .
			"ORDER BY mod_order ASC"
		);

		if (is_array($modules)) {

			//process for extra modules
			foreach ($modules as $key => $val) {
				$val["settings"] = unserialize($val["mod_settings"]);

				switch ($val["mod_module_code"]) {
					case "external-link":
						$modules[$key]["url"] = $val["settings"]["set_link"];
						$modules[$key]["target"] = $val["settings"]["set_target"]; 
					break;

					case "category":
						$modules[$key]["url"] = "javascript:void(0);";
						$modules[$key]["target"] = "";
					break;

					default:
						$modules[$key]["url"] = (!$this->vars->data["set_links_type"] ? "index.php/" : "") . $val["mod_url"] . "/";
						$modules[$key]["target"] = "";
					break;
				}
			}

			//process for building the tree
			foreach ($modules as $key => $val) {
				if ($val["mod_id"] == $this->module->tpl_module["mod_id"] ) {
					$current = $val["mod_parent"] ? $val["mod_parent"] : $val["mod_id"];
				}
				
				if (!$val["mod_parent"]) {
					$_modules[$val["mod_id"]] = $val;
				}			
			}
			
			//detect the kids
			foreach ($modules as $key => $val) {
				if ($val["mod_parent"] && $_modules[$val["mod_parent"]]) {
					$_modules[$val["mod_parent"]]["sub"][] = $val;
				}			
			}


			//process the kids
			foreach ($_modules as $key => $val) {
				if (is_array($val["sub"])) {
					$_modules[$key]["subitems"] = $base->html->table(
						$this->private->templates["menu"],
						"Sub",
						$val["sub"]
					);
				} else
					$_modules[$key]["subitems"] = "";				
				
				$_modules[$key]["active"] = $current == $key ? $this->private->templates["menu"]->blockREplace("Active" , array()) : "";
				
			}

			//process modules for footer
			if ($this->vars->data["set_footer_type"]) {
				$links = explode("\n" , trim($this->vars->data["set_footer_links"]));

				if (count($links)) {
					foreach ($links as $key => $val) {
						$val = explode("|" , trim($val));

						$_footer_modules[] = array(
							"url"		=> $val[1],
							"mod_name"	=> $val[0],
						);
					}					
				}				
			} else {			
				if (is_array($_modules)) {
					foreach ($_modules as $key => $val) {
						if (!$val["subitems"])						
							$_footer_modules[] = $val;
					}				
				}
			}


			//check for shopping cart
			$shop = $this->module->plugins["modules"]->LoadDefaultModule("shop");

			if ($shop["module_unique_enabled"]) {
				if (is_array($shop)) {
					if (!$this->vars->data["set_links_type"]) {
						$shop["mod_url"] = "index.php/" . $shop["settings"]["set_url"];				
					} else {
						$shop["mod_url"] = $shop["settings"]["set_url"];				
					}
				}

				$_modules[] = array(
					"mod_name"	=> CTemplateStatic::Replace(
										$shop["settings"]["set_title"],
										array(
											"items"	=> count($_SESS["cart"])
										)
									),
					"url"		=> $shop["mod_url"] . "/",
					"subitems"	=> ""
				);
			}
			
			return array(
				"top" => $base->html->Table(
					$this->private->templates["menu"],
					"",
					$_modules
				),

				"footer" => $base->html->Table(
					$this->private->templates["menu"],
					"Footer",
					$_footer_modules
				),
			);			
		}		
	}

	function LoadModuleInfo() {

		//read the small 
		$module = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['core:modules']} , {$this->tables['core:user_modules']} " . 
			"WHERE module_id=mod_module AND mod_id=" .(int)$_GET[module_id] 
		);

		if (is_array($module)) {
			$module["settings"] = (array) unserialize($module["mod_settings"]);
			$module["default"] = unserialize($module["module_settings"]);
		}

		if (is_array($module)) {
			if (!$this->vars->data["set_links_type"]) {
				$module["mod_url"] = "index.php/" . $module["mod_url"];
			}
		}

		$this->module->tpl_module = $module;

		return $module;
	}

	function LoadDefaultModule($mod) {

		//read the small 
		$module = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['core:modules']} " . 
			"WHERE module_code='{$mod}'"
		);


		if (is_array($module)) {
			$module["settings"] = unserialize($module["module_settings"]);
		}

		if (is_array($module)) {
			if (!$this->vars->data["set_links_type"]) {
				$module["mod_url"] = "index.php/" . $module["mod_url"];				
			}
		}

		$this->module->tpl_module = $module;

		return $module;
	}

	
	

	function GetModuleByCode($module , $htaccess = false) {

		//read the small 
		$_module = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['core:user_modules']} " . 
			"WHERE mod_url='{$module}'"
		);

		if (is_array($_module)) {
			if (!$this->vars->data["set_links_type"] && !$htaccess) {
				$_module["mod_url"] = "index.php/" . $_module["mod_url"];
			}
		}

		return $_module;
	}

	function GetModuleByID($module , $htaccess = false) {

		//read the small 
		$_module = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['core:user_modules']} " . 
			"WHERE mod_id='{$module}'"
		);

		if (is_array($_module)) {
			$_module["settings"] = (array) unserialize($_module["mod_settings"]);
			$_module["default"] = unserialize($_module["module_settings"]);

			if (!$this->vars->data["set_links_type"] && !$htaccess) {
				$_module["mod_url"] = "index.php/" . $_module["mod_url"];
			}
		}

		return $_module;
	}


	function GetFirstModuleByCode() {

		//read the small 
		$_module = $this->db->QFetchArray(
			"SELECT * FROM {$this->tables['core:user_modules']} " . 
			"WHERE mod_parent=0 " . 
			"ORDER BY mod_order ASC LIMIT 1"
		);

		if (is_array($_module)) {
		}
		

		return $_module;
	}

	/**
	* description
	*
	* @param
	*
	* @return
	*
	* @access
	*/
	function GetIdFromLink($link) {
		$tmp = explode("-" , $link);

		return trim($tmp[count($tmp)-1]);
	}

	function SetSeo($item) {
		global $_TSM;

		if ($item["seo_title"] && !$_TSM["PUB:SEO_TITLE"])
			$_TSM["PUB:SEO_TITLE"] = $item["seo_title"];

		if ($item["seo_desc"] && !$_TSM["PUB:SEO_DESC"])
			$_TSM["PUB:SEO_DESC"] = $item["seo_desc"];

		if ($item["seo_keys"] && !$_TSM["PUB:SEO_KEYS"])
			$_TSM["PUB:SEO_KEYS"] = $item["seo_keys"];
		
	}

	function MimeXML() {
		$mime = new CMime();
		$mime->Set("xml");
	}

	function Redirect404() {
		global $_CONF;

		$url = $this->vars->data["set_error_404"] ?  $this->vars->data["set_error_404"] : "/";

		if (!$this->vars->data["set_links_type"]) {
			$url = "index.php/" . $url;

			//remove the double //
			$url = str_replace("//" , "/" , $url);
			
			$url = $_CONF["url"] . $url;

		}		

		header("HTTP/1.1 404 Not Found");
		header("Location: {$url}");
		exit();
	}
	
	/**
	* description
	*
	* @param
	*
	* @return
	*
	* @access
	*/
	function ModuleInfo($module , $subtitle = "" , $search = "") {
		$this->__init();

		if (!$module["mod_show_header"]) {
			return "";
		}		

		return $this->private->templates["info"]->Blockreplace(
			"Header",
			array(
				"title" => $module["mod_long_name"],
				"description" => $subtitle ? $subtitle : $module["mod_description"],		

				"search"	=> $search,

				"class"		=> $search ? "meta_search" : "",
			)
		);
	}

		
	/**
	* description
	*
	* @param
	*
	* @return
	*
	* @access
	*/
	function BreadCrumb($links = array()) {
		global $base , $_CONF;

		$this->__init();

		if (is_array($links)) {

			$links = array_merge(
				array("Home" => $_CONF["url"]),
				$links
			);


			$cnt = 1;
			foreach ($links as $key => $val) {
				$_links[] = array(
					"content"	=> $this->private->templates["breadcrumb"]->blockReplace(
						$val ? "Link" : "NoLink" , 
						array(
							"title"	=> $key,
							"link"	=> $val
						)
					),
					"extra"	=> $cnt < count($links) ? $this->private->templates["breadcrumb"]->Blockreplace(
						"Sep",
						array()
					) : "",
				);

				$cnt ++;
			}			
		}

		if (is_Array($_links)) {
			return $base->html->Table(
				$this->private->templates["breadcrumb"],
				"",
				$_links
			);
		}
		
		
	}
	
	
}

?>