<?php
/*
	OXYLUS Development web framework
	copyright (c) 2002-2007 OXYLUS Development
		web:  www.oxylus.ro
		mail: support@oxylus.ro		

	$Id: name.php,v 0.0.1 dd/mm/yyyy hh:mm:ss oxylus Exp $
	description
*/

// dependencies

/**
* description
*
* @library	
* @author	
* @since	
*/
class COXYMallShop extends CPlugin{	
	
	var $tplvars; 

	function COXYMallShop() {
		//$this->CPlugin($db, $tables , $templates);
	}

	function DoEvents(){
		global $base, $_CONF, $_TSM , $_VARS , $_USER , $_BASE , $_SESS;

		parent::DoEvents();
		
		if (stristr($_GET["sub"] , "oxymall.plugin.shop")) {
			$sub = str_replace("oxymall.plugin.shop." , "" , $_GET["sub"]);

			$this->__init();
			$this->tpl_module = $this->module->plugins["modules"]->LoadDefaultModule("shop");

			if (!$this->vars->data["set_links_type"]) {
					$this->tpl_module["mod_url"] = "index.php/" . $this->tpl_module["settings"]["set_url"] . "/";				
			} else
				$this->tpl_module["mod_url"] = $this->tpl_module["settings"]["set_url"] . "/";


			$_TSM["TOP:MODULE_INTRO"] = $this->module->plugins["modules"]->ModuleInfo($this->tpl_module);
			
			switch ($sub) {
				case "cart":
					return $this->ViewCart();
				break;

				case "update":
					return $this->UpdateCart();
				break;

				case "empty":
					return $this->EmptyCart();
				break;

				case "delete":
					return $this->DeleteItem();
				break;

				case "checkout":
					return $this->Checkout();
				break;

				case "ipn":
					return $this->IPN();
				break;

				case "download":
					return $this->Download();
				break;

				case "success":
					return $this->Success();
				break;
			}
		}
	}

	function __init() {
		global $_CONF;

		if ($this->__inited) {
			return "";
		}

		$this->__inited = true;
		
		$path = "templates/modules/shop/";

		$templates = array(
			"cart"		=> "cart.htm",
			"paypal"	=> "paypal.htm",
			"mail"	=> "mail.htm",
		);

		foreach ($templates as $key => $val) {
			$this->private->templates[$key] = new CTemplateDynamic(
				$path . $val
			);
		}

	}

	function ViewCart() {
		global $_SESS , $base , $_TSM;

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				"Cart" => $this->tpl_module["mod_url"] 
			)
		);

		if (is_Array($cart = $_SESS["cart"])) {
			foreach ($cart as $key => $val) {
				$product = $this->module->plugins["products"]->__bk_get_product_by_id($val["pid"]);
				if (is_array($product)) {
					
					$cart[$key]["cnt"] = ++$cnt;
					$cart[$key]["name"]	= $product["item_title"];
					$cart[$key]["sku"]	= $product["item_sku"];
					$cart[$key]["price"] = $this->module->plugins["products"]->ProcessSinglePrice($product["item_price"] , true);
					$cart[$key]["price_original"] = $product["item_price"];
					$cart[$key]["key"] = $key;

					//process shipping 
					if ($product["item_set_shipping"]) {
						$total_shipping += $product["item_price"] * $val["qty"];
					}

					$cart[$key]["raw"] = $product;

					if (is_Array($val["options"])) {
						$options = array();
						foreach ($val["options"] as $_key => $_val) {
							$options[] = $this->private->templates["cart"]->blockReplace(
								"OptionsElement",
								array(
									"title"	=> $_key,
									"value"	=> $_val
								)
							);
						}

						$cart[$key]["options"] = $this->private->templates["cart"]->blockReplace(
							"Options",
							array(
								"options"	=> implode(", " , $options )
							)
						);						
					} else{
						$options = array();
						$cart[$key]["options"] = "";
					}
				}				
			}			
		}

		if (is_array($cart)) {
			$total = 0;
			$alternance = 0;

			foreach ($cart as $key => $val) {
				$cart[$key]["alt"] = $this->private->templates["cart"]->blockReplace("CartAlt" .(int)$alternance , array());
				$cart[$key]["total"] = $this->module->plugins["products"]->ProcessSinglePrice($val["price_original"] * $val["qty"] , true);
				$total += $val["price_original"] * $val["qty"];

				$alternance = !$alternance;

			}			

			$prices["subtotal"] = $total;
			$prices["discount"]	= $this->CalcDiscount($total , $cart);
			$prices["shipping"]	= $this->CalcShipping($total_shipping , $cart);
			$prices["tax"]		= $this->CalcTax($total , $cart);
			$prices["total"]	= $prices["subtotal"]  + $prices["discount"] + $prices["shipping"]  + $prices["tax"] ;

		}		
		
		return CTemplateStatic::Replace(
			$this->private->templates["cart"]->blockreplace(
				"Main",
				array(
					"content"	=> $base->html->table(
										$this->private->templates["cart"],
										"Cart",	
										$cart
									),
					"mod_url"	=> $this->tpl_module["mod_url"], 
				)
			),
			array(
				"subtotal"	=> $this->module->plugins["products"]->ProcessSinglePrice($prices["subtotal"], true),
				"discount"	=> $this->module->plugins["products"]->ProcessSinglePrice($prices["discount"], true),
				"shipping"	=> $this->module->plugins["products"]->ProcessSinglePrice($prices["shipping"], true),
				"total"		=> $this->module->plugins["products"]->ProcessSinglePrice($prices["total"], true),
				"tax"		=> $this->module->plugins["products"]->ProcessSinglePrice($prices["tax"], true),

				"checkout"	=> count($cart) ? $this->private->templates["cart"]->BlockReplace(
						"Checkout",
						array(
							"mod_url"	=> $this->tpl_module["mod_url"], 
						)
					) : "",

				"update"	=> count($cart) ? $this->private->templates["cart"]->BlockReplace(
						"Update",
						array()
					) : "",

			)

		);
	}

	function CalcDiscount($total , $cart) {
		$discount = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:shop_discounts']} WHERE discount_amount <= {$total} ORDER BY discount_amount DESC LIMIT 1");

		if (is_array($discount)) {
			switch ($discount["discount_type"]) {
				case "1":
					return -($total * $discount["discount_discount"] / 100);
				break;

				case "2":
					return -($discount["discount_discount"]);
				break;
			}
			
		}
		
	}
	
	function CalcShipping($total , $cart) {

		if (!$total) {
			return 0;
		}

		$shipp = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:shop_shipping']} WHERE shipp_amount >= {$total} ORDER BY shipp_amount ASC LIMIT 1");

		return $shipp["shipp_price"];

	}

	function CalcTax($total , $cart) {
		if (is_array($cart)) {

			$total_tax = 0;

			foreach ($cart as $key => $val) {
				if ($val["raw"]["item_set_tax"]) {
					$tax = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:shop_tax']} WHERE tax_id={$val[raw][item_set_tax]}");


					if (is_Array($tax)) {

						$total_tax += ($val["raw"]["item_price"] * $val["qty"]) * $tax["tax_amount"] / 100;
					}
					
				}				
			}
			
		}

		return $total_tax;
		
	}


	function UpdateCart() {
		global $_SESS , $_CONF;

		if ($_SERVER["REQUEST_METHOD"] == "POST") {
			if (is_array($_SESS["cart"])) {
				foreach ($_SESS["cart"] as $key => $val) {
					$_SESS["cart"][$key]["qty"] = $_POST[p][$key];
				}				
			}

			if (is_array($_SESS["cart"])) {
				foreach ($_SESS["cart"] as $key => $val) {
					if ((int)$val["qty"]) {
						$cart[] = $val;
					}
				}				

				$_SESS["cat"] = $cart;
			}
		}

		header("Location: {$_CONF[url]}{$this->tpl_module[mod_url]}");
		exit();
	}
	

	function DeleteItem() {
		global $_CONF , $_SESS;

		if (is_array($_SESS["cart"][$_GET["p"]])) {
			unset($_SESS["cart"][$_GET["p"]]);

		}

		header("Location: {$_CONF[url]}{$this->tpl_module[mod_url]}");
		exit();		
	}

	function Checkout() {
		global $_SESS , $_CONF;

		if (is_Array($cart = $_SESS["cart"])) {
			foreach ($cart as $key => $val) {
				$product = $this->module->plugins["products"]->__bk_get_product_by_id($val["pid"]);
				$cart[$key]["raw"] = $product;
			}
		}


		//check if i detect shipping
		if (is_Array($cart)) {
			foreach ($cart as $key => $val) {
				if ($val["raw"]["item_set_shipping"] || $val["raw"]["item_set_shipping_flat"]) {
					$shipping = true;
				}
			}
		}
		
		return $this->Paypal($cart);
	}
	
	function Paypal($cart) {
		global $_TSM , $_CONF;

		$_TSM["PUB:BREADCRUMB"] = $this->module->plugins["modules"]->BreadCrumb(
			array(
				"Cart" => $this->tpl_module["mod_url"] ,
				"Redirecting to Paypal" => "" 
			)
		);


		if (!$this->vars->data["set_shop_paypal"]) {
			return "Please configure the paypal account in admin->[shop module]->global settings";
		}

		$form["business"] = $this->vars->data["set_shop_paypal"];
		$form["cmd"] = "_cart";
		$form["upload"] = "1";
		$form["currency_code"] = strtoupper($this->vars->data["set_shop_currency"]);
		$form["cancel_return"] = $_CONF["url"] . $this->tpl_module["mod_url"];
		$form["notify_url"] = $_CONF["url"] . "ipn.php";
		$form["return"] = $_CONF["url"] . "checkout-success.php";

		if (is_array($cart)) {
			$count = 1;
			$total = 0;
			$tax_total = 0;
			foreach ($cart as $key => $val) {
				$form["item_name_{$count}"] = $val["raw"]["item_title"];
				$form["amount_{$count}"] = $val["raw"]["item_price"];
				$form["quantity_{$count}"] = $val["qty"];
				$form["on0_{$count}"] = "SKU";
				$form["os0_{$count}"] = $val["raw"]["item_sku"];

				$total += $val["raw"]["item_price"] * $val["qty"];

				if ($val["raw"]["item_set_shipping"]) {
					$total_shipping += $val["raw"]["item_price"] * $val["qty"];
				}

				$cnt = 1;

				if (is_array($val["options"]) && count($val["options"])) {
					foreach ($val["options"] as $k => $v) {
						$form["on{$cnt}_{$count}"] = $k;
						$form["os{$cnt}_{$count}"] = $v;

						$cnt ++;
					}					
				}

				if ($val["raw"]["item_set_tax"]) {
					$tax = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:shop_tax']} WHERE tax_id={$val[raw][item_set_tax]}");

					if (is_array($tax)) {
						$tax_total += $val["raw"]["item_price"] * $tax["tax_amount"] / 100;
					}
				}

				$count ++;
			}			


			$discount = $this->CalcDiscount($total , $cart);		
			$shipping = $this->CalcShipping($total_shipping , $cart);
			$tax_total = $this->CalcTax($total , $cart);

			$form["shipping_1"] = $shipping;
			$form["discount_amount_cart"] = abs($discount);
			$form["tax_cart"] = number_format($tax_total,2);
		}

		if (is_array($form)) {
			foreach ($form as $key => $val) {

				$content .= $this->private->templates["paypal"]->blockReplace(
					"Field",
					array(
						"name"	=> $key,
						"value"	=> $val
					)
				);
			}
			

			return $this->private->templates["paypal"]->blockReplace(
				"Paypal",
				array(
					"form"	=> $content
				)
			);
			
		}

	}

	
	function IPN() {
		global $base ,$_CONF;

		//SaveFileContents("n/" . time() . ".txt" , serialize($_POST));
		//$_POST = unserialize(GetFileContents("n/1275568476.txt"));

		$data = $_POST;

		$paypal = new CPaypal($this->vars->data["set_shop_paypal"]);

		if (is_array($return = $paypal->IPN())) { 

			$order = array(
				"order_date"			=> time(),
				"order_status"			=> 1,
				"order_payment_date"	=> $data["payment_date"],
				"order_payment_status"	=> $data["payment_status"],
				"order_first_name"		=> $data["first_name"],
				"order_last_name"		=> $data["last_name"],
				"order_business"		=> $data["payer_business_name"],
				"order_address_status"	=> $data["address_status"],
				"order_address_street"	=> $data["address_street"],
				"order_address_zip"		=> $data["address_zip"],
				"order_address_country"	=> $data["address_country"],
				"order_address_city"	=> $data["address_city"],
				"order_address_state"	=> $data["address_state"],
				"order_price_total"		=> $data["mc_gross"],
				"order_price_tax"		=> $data["tax"],
				"order_price_shipping"	=> $data["mc_shipping"],
				"order_price_handling"	=> $data["mc_handling"],
				"order_price_discount"	=> $data["discount"],
				"order_price_fee"		=> $data["mc_fee"],
				"order_price_currency"	=> $data["mc_currency"],
				"order_payer_id"		=> $data["payer_id"],
				"order_payer_email"		=> $data["payer_email"],
				"order_payer_status"	=> $data["payer_status"],
				"order_products_count"	=> $data["num_cart_items"],
				"order_verify_sign"		=> $data["verify_sign"],
				"order_txn_id"			=> $data["txn_id"],
				"order_payment_type"	=> $data["payment_type"],
			);

			if (is_array($this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:shop_orders']} WHERE order_txn_id='{$order[order_txn_id]}'"))) {
				$this->db->QueryUpdate(
					$this->tables['plugin:shop_orders'],
					$order,
					"order_txn_id='" . $order["order_txn_id"] . "'"
				);
			} else {

				$id = $this->db->QueryInsert(
					$this->tables["plugin:shop_orders"],
					$order
				);

				for ($i = 1; $i <= $order["order_products_count"]; $i++ ) {
					$product = array(
						"item_order"		=> $id,
						"item_date"			=> time(),
						"item_product"		=> $data["item_name" . $i],
						"item_product_sku"	=> $data["option_selection1_" . $i],
						"item_price"		=> $data["mc_gross_" . $i] / $data["quantity" . $i],
						"item_total"		=> $data["mc_gross_" . $i],
						"item_tax"			=> $data["tax" . $i],
						"item_shipping"		=> $data["mc_shipping" . $i],
						"item_handling"		=> $data["mc_handling" . $i],
						"item_quantity"		=> $data["quantity" . $i],
						"item_code"			=> md5($data["item_name" . $i] . time() . uniqid()),
					);

					//detect the options
					$options = array();
					for ($j = 2; $j <= 20; $j++ ) {
						if ($data["option_name{$j}_{$i}"]) {
							$options[] = $data["option_name{$j}_{$i}"] . ": " . $data["option_selection{$j}_{$i}"];
						}
					}

					
					$product["item_options"] = implode(", " , $options);

					//get the old product info
					$prod_data = $this->db->QFetchArray("SELECT * FROM {$this->tables['plugin:shop_items']} WHERE item_sku='{$product[item_product_sku]}'");

					//process for downaloads 
					if ($prod_data["item_set_electronic"]) {
						$product["item_downloadable"] = "1";
					}
					
					$this->db->QueryInsert(
						$this->tables["plugin:shop_cart"],
						$product
					);


					$cart[] = $product;

					//update the sales count for this product
					$this->db->Query(
						"UPDATE {$this->tables['plugin:shop_items']} SET item_sales = item_sales+1 WHERE item_sku='{$product[item_product_sku]}'"
					);

				}			
			}


			//send the notification mails
			

			//build the cart content

			$this->__Init();

			if (is_array($cart)) {
				foreach ($cart as $key => $val) {
					$cart[$key]["cnt"] = ++$cnt;

					$val["site:url"] = $_CONF["url"];

					if ($order["order_payment_status"] == "Completed") {
						$cart[$key]["download"] = $val["item_downloadable"] ? $this->private->templates["mail"]->BlockReplace(
							"Download",
							$val
						) : "";
					} else {
						$cart[$key]["download"] = "";
					}
				}
				
				$order["cart_content"] = $base->html->Table(
					$this->private->templates["mail"],
					"",
					$cart					
				);

				$order["cart_content_admin"] = $base->html->Table(
					$this->private->templates["mail"],
					"",
					$cart					
				);

			}
			
			//notifications to admin
			$email = array(
				"email_to" => utf8_decode($this->tpl_module["settings"]["set_email_1_to_email"]),
				"email_to_name" => utf8_decode($this->tpl_module["settings"]["set_email_1_to_name"]),

				"email_from" => utf8_decode($this->tpl_module["settings"]["set_email_1_from_email"]),
				"email_from_name" => utf8_decode($this->tpl_module["settings"]["set_email_1_from_name"]),

				"email_subject" => utf8_decode($this->tpl_module["settings"]["set_email_1_subject"]),

				"email_body" => utf8_decode($this->tpl_module["settings"]["set_email_1_message"]),
				"email_type" => "html"
			);

			foreach ($email as $key => $val) {
				$email[$key] = CTemplateStatic::Replace($val , $order);
			}


			//send the email
			$this->module->plugins["mail"]->SendMail($email);


			//send the email to the user

			if ($order["order_payment_status"] == "Pending") {
				$subject = utf8_decode($this->tpl_module["settings"]["set_email_4_subject"]);
				$message = utf8_decode($this->tpl_module["settings"]["set_email_4_message"]);
			} else {
				$subject = utf8_decode($this->tpl_module["settings"]["set_email_3_subject"]);
				$message = utf8_decode($this->tpl_module["settings"]["set_email_3_message"]);
			}
			
			//notifications to admin
			$email = array(
				"email_to" => utf8_decode($order["order_payer_email"]),
				"email_to_name" => utf8_decode($order["order_first_name"] . " " . $order["order_last_name"]),

				"email_from" => utf8_decode($this->tpl_module["settings"]["set_email_2_to_email"]),
				"email_from_name" => utf8_decode($this->tpl_module["settings"]["set_email_2_to_name"]),

				"email_subject" => $subject,

				"email_body" => $message,
				"email_type" => "html"
			);

			foreach ($email as $key => $val) {
				$email[$key] = CTemplateStatic::Replace($val , $order);
			}


			//send the email
			$this->module->plugins["mail"]->SendMail($email);
		}

		echo "ok";
		die();
	}

	function Download() {

		if ($_GET["file"]) {
			$product = $this->db->QFetchArray(
				"SELECT *,product.item_id as pid FROM {$this->tables['plugin:shop_cart']} as cart,{$this->tables['plugin:shop_orders']},{$this->tables['plugin:shop_items']} as product " . 
				"WHERE cart.item_code=\"{$_GET[file]}\" AND order_id=cart.item_order AND product.item_sku=cart.item_product_sku AND cart.item_downloadable=1 AND order_payment_status='Completed' "
			);

			if (is_array($product)) {

				if ($product["item_downloads"]	>= $this->tpl_module["settings"]["set_electronic_dl"]) {

					$redirect = $this->module->plugins["modules"]->GetModuleByID($this->tpl_module["settings"]["set_downloads_exceeded"]);

					if (is_Array($redirect)) {
						urlredirect($redirect["mod_url"] . "/");
					}
					
					die("Improper configured");
				}

				//update the downloads number
				$this->db->QueryUpdate(
					$this->tables["plugin:shop_cart"],
					array(
						"item_downloads" => $product["item_downloads"] + 1,
					),
					"item_code='{$_GET[file]}'"
				);

				$mime = new CMime();
				$mime->Set("unknown");
				$mime->FileName($product["item_set_electronic_file_file"]);

				readfile("upload/private/file_{$product[pid]}.zip");

				die();
			}
			
		}

		$redirect = $this->module->plugins["modules"]->GetModuleByID($this->tpl_module["settings"]["set_invalid_download"]);

		if (is_Array($redirect)) {
			urlredirect($redirect["mod_url"] . "/");
		}
		
		die("Improper configured");		
	}

	function Success() {
		global $_SESS;

		//remove the cart
		if (isset($_SESS["cart"]))
			unset($_SESS["cart"]);

		$redirect = $this->module->plugins["modules"]->GetModuleByID($this->tpl_module["settings"]["set_success_url"]);

		if (is_Array($redirect)) {
			urlredirect($redirect["mod_url"] . "/");
		}
	}
	


	
}

?>